/***************************************************************************
 * Gens: (Win32) Main Window - Non-Menu Command Definitions.               *
 *                                                                         *
 * Copyright (c) 1999-2002 by Stéphane Dallongeville                       *
 * Copyright (c) 2003-2004 by Stéphane Akhoun                              *
 * Copyright (c) 2008 by David Korth                                       *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifndef GENS_WIN32_GENS_WINDOW_CMDS_H
#define GENS_WIN32_GENS_WINDOW_CMDS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */

#ifdef __cplusplus
extern "C" {
#endif

// Non-Menu Commands
#define IDCMD_NONMENU_COMMANDS		0x7000
#define IDCMD_ESC			0x7001
#define IDCMD_PAUSE			0x7002
#define IDCMD_FRAMESKIP_AUTO		0x7003
#define IDCMD_FRAMESKIP_DEC		0x7004
#define IDCMD_FRAMESKIP_INC		0x7005
#define IDCMD_SAVESLOT_DEC		0x7006
#define IDCMD_SAVESLOT_INC		0x7007
#define IDCMD_SWBLIT			0x7008
#define IDCMD_FASTBLUR			0x7009
#define IDCMD_YM2612_IMPROVED		0x700A
#define IDCMD_DAC_IMPROVED		0x700B
#define IDCMD_PSG_IMPROVED		0x700C
#define IDCMD_FPS			0x700D
#define IDCMD_RENDERMODE_DEC		0x700E
#define IDCMD_RENDERMODE_INC		0x700F
#define IDCMD_CHANGE_CD			0x7010
#define IDCMD_STRETCH_MODE		0x7011

// Non-Menu Commands - Save Slot Numbers
#define IDCMD_SAVESLOT_NUMERIC		0x7100 // Same as IDCMD_SAVESLOT_NUMERIC_0
#define IDCMD_SAVESLOT_NUMERIC_0	0x7100
#define IDCMD_SAVESLOT_NUMERIC_1	0x7101
#define IDCMD_SAVESLOT_NUMERIC_2	0x7102
#define IDCMD_SAVESLOT_NUMERIC_3	0x7103
#define IDCMD_SAVESLOT_NUMERIC_4	0x7104
#define IDCMD_SAVESLOT_NUMERIC_5	0x7105
#define IDCMD_SAVESLOT_NUMERIC_6	0x7106
#define IDCMD_SAVESLOT_NUMERIC_7	0x7107
#define IDCMD_SAVESLOT_NUMERIC_8	0x7108
#define IDCMD_SAVESLOT_NUMERIC_9	0x7109

// Non-Menu Commands - ROM History
#define IDCMD_ROMHISTORY_NUMERIC	0x7200
#define IDCMD_ROMHISTORY_NUMERIC_1	0x7201
#define IDCMD_ROMHISTORY_NUMERIC_2	0x7202
#define IDCMD_ROMHISTORY_NUMERIC_3	0x7203
#define IDCMD_ROMHISTORY_NUMERIC_4	0x7204
#define IDCMD_ROMHISTORY_NUMERIC_5	0x7205
#define IDCMD_ROMHISTORY_NUMERIC_6	0x7206
#define IDCMD_ROMHISTORY_NUMERIC_7	0x7207
#define IDCMD_ROMHISTORY_NUMERIC_8	0x7208
#define IDCMD_ROMHISTORY_NUMERIC_9	0x7209

#ifdef __cplusplus
}
#endif

#endif /* GENS_WIN32_GENS_WINDOW_CMDS_H */
